<template>
  <nav>
    <navigation-user style="grid-area: user" />
    <navigation-list style="grid-area: main-list">
      <navigation-link
        to="/do_potwierdzenia"
        name="Do potwierdzenia"
        :icon="icons.faInbox"
        :unread_count="unaccepted_count"
      />
      <navigation-link
        to="/operacje"
        name="Operacje"
        :icon="icons.faCalendar"
      />
      <navigation-link
        to="/wyposazenie"
        name="Wyposażenie"
        :icon="icons.faToolbox"
      />
      <navigation-link
        to="/lokalizacje"
        name="Lokalizacje"
        :icon="icons.faMapMarkerAlt"
      />
      <navigation-link to="/osoby" name="Osoby" :icon="icons.faUsers" />
    </navigation-list>
    <navigation-list style="grid-area: logout">
      <navigation-link
        v-on:click.prevent.stop="logout"
        to="/logowanie"
        name="Wyloguj"
        :icon="icons.faSignOutAlt"
      />
    </navigation-list>
  </nav>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";
import NavigationLink from "@/components/navigation/NavigationLink.vue";
import NavigationList from "@/components/navigation/NavigationList.vue";
import NavigationUser from "@/components/navigation/NavigationUser.vue";

import {
  faInbox,
  faToolbox,
  faMapMarkerAlt,
  faUsers,
  faCalendar,
  faSignOutAlt,
} from "@fortawesome/free-solid-svg-icons";
import { useRouter } from "vue-router";
import { NApi } from "@/interfaces/connector";

@Options({
  components: {
    NavigationLink,
    NavigationList,
    NavigationUser,
  },
})
export default class Navigation extends Vue {
  public router = useRouter();
  public unaccepted_count = 0;

  public couter!: number;

  public icons = {
    faInbox,
    faToolbox,
    faMapMarkerAlt,
    faUsers,
    faCalendar,
    faSignOutAlt,
  };

  public mounted(): void {
    this.load_bubble();
    this.couter = setInterval(this.load_bubble, 10000);
  }

  public unmounted(): void {
    clearInterval(this.couter);
  }

  public async load_bubble(): Promise<void> {
    try {
      this.unaccepted_count = (await NApi.getUnacceptedActions()).length;
    } catch (e) {
      console.error(e);
    }
  }

  public logout(): void {
    window.localStorage.removeItem("token");
    this.router.push("/logowanie");
  }
}
</script>

<!-- Add `scoped` attribute to limit CSS to this component only -->
<style scoped lang="scss">
@import "@/styles/globals";

nav {
  display: grid;
  grid-template-columns: 1fr;
  grid-template-rows: auto auto 1fr auto 25px;
  grid-template-areas:
    "user"
    "main-list"
    "."
    "logout"
    ".";

  background-color: $light_bg;
  box-shadow: inset -4px 0px 3px -4px $shadow_grey;
}
</style>
